
%{
/* need this for the call to atof() below */
#include <math.h>
#include <fcntl.h>
#include <ctype.h>
#include <unistd.h>
#include "mv1.h"

#define YY_INPUT(buf,result,max_size) \
 { int c = getc( yyin ); \
  result = c == EOF ? 0 : 1; \
  buf[0] = (char) c; \
 }
#define YY_DECL int read_camcfg(camcfg)MV1_CamConfig *camcfg;

#define ECHO                  
//#define ECHO (void) fwrite( yytext, yyleng, 1, yyout );\
 //    fflush(yyout);

double asctof(char*); 
char filename[80];

static void ignored( char *str) {
	fprintf(stderr,"ignored:  %s\n",str);
}
%}

DIGIT    [0-9]
NUMBER	[0-9a-f.x]*
INTEGER  {DIGIT}+
FLOAT   {DIGIT}+[.]+{DIGIT}*
SPC     [ \011
]*
COM 	{SPC};.*|

%%
"Version=".* {

}
"Camera_ID=".* {

}
"Video_Channel="{NUMBER}{COM} {
	camcfg->videoChannel = asctof(yytext) ;
}
"Sync_Channel="{NUMBER}{COM} {
	camcfg->syncChannel = asctof(yytext);
}
"H_Offset="{NUMBER}{COM} {
	camcfg->hOffset=asctof(yytext);
}
"V_Offset="{NUMBER}{COM} {
	camcfg->vOffset = asctof(yytext);
}
"Clamp_Control="{NUMBER}{COM} {
	camcfg->ClampControl = asctof(yytext);
}
"AD_Convert_Top="{NUMBER}{COM} {
	camcfg->ADTop = asctof(yytext);
}
"AD_Convert_Bottom="{NUMBER}{COM} {
	camcfg->ADBottom = asctof(yytext);
}
"Clamp_Level="{NUMBER}{COM} {
	camcfg->ClampLevel = asctof(yytext);
}
"DC_Offset="{NUMBER}{COM} {
	camcfg->DCOffset = asctof(yytext);
}
"Filter_Cutoff="{NUMBER}{COM} {
	camcfg->filterCutoff = (asctof(yytext)+0.762)/0.1474;
	if(camcfg->filterCutoff > 127) {
		camcfg->filterCutoff = 127;
	}
	else if(camcfg->filterCutoff < 42) {
		camcfg->filterCutoff = 42;
	}
}
"Filter_Boost="{NUMBER}{COM} {
	camcfg->filterBoost = asctof(yytext);
}


"Pixel_Per_Line="{NUMBER}{COM} {
	camcfg->pll.PixelPerLine = asctof(yytext);
}
"H_Period="{NUMBER}{COM} {
	camcfg->pll.hPeriod = asctof(yytext);
}
"Phase_Trimming="{NUMBER}{COM} {
	camcfg->pll.PhaseTriming = asctof(yytext);
}
"Clock_Reference_Select="{NUMBER}{COM} {
	camcfg->pll.clockReference = asctof(yytext);
}
"Lead_Lag="{NUMBER}{COM} {
	camcfg->pll.LeadLag = asctof(yytext);
}
"Pixel_Clock_Freq="{NUMBER}{COM} {
	camcfg->pll.PixelClockFreq = asctof(yytext);;
}


%{
    // camera drive control ! 

%}



"Camera_Master_Clock="{NUMBER}{COM} {
	camcfg->cameraMasterClock=asctof(yytext);
}
"Camera_Interlace="{NUMBER}{COM} {
	camcfg->cameraInterlace = asctof(yytext);
}
"Camera_Drive_VPolarity="{NUMBER}{COM} {
	camcfg->cameraDriveVPolarity = asctof(yytext);
}
"Camera_Drive_HPolarity="{NUMBER}{COM} {
	camcfg->cameraDriveHPolarity = asctof(yytext);	
}
%{ 
   //  cameraSyncOutput
%}
"Camera_CSync_Output="{NUMBER}{COM} {
	camcfg->cameraCSyncOutput = asctof(yytext);
}
"Tim_Gen_Clock_D4="{NUMBER}{COM} {
	camcfg->cameraClockDivideBy4 = asctof (yytext); // ????????????
}
"Drive_Through_Module="{NUMBER}{COM} {
	camcfg->cameraDriveThroughModule = asctof(yytext);
}
%{
  // cameraHGatePolarity
%}
"Camera_Drive_Width="{NUMBER}{COM} {
	camcfg->cameraDriveWidth = asctof(yytext);
}
"Camera_Drive_Height="{NUMBER}{COM} {
	camcfg->cameraDriveHeight = asctof(yytext);
}
"Camera_Pixel_Per_Line="{NUMBER}{COM} {
	camcfg->cameraPixelPerLine=asctof(yytext);
}
%{	
  // cameraClockFrequency
%} 

"Camera_Line_Per_Frame="{NUMBER}{COM} {
	camcfg->cameraLinePerFrame = asctof(yytext);
}
"Flag_EquSerr="{NUMBER}{COM} {
	camcfg->cameraFlag_EquSerr = asctof(yytext);
}
"Eq_Start="{NUMBER}{COM} {
	camcfg->cameraEq_Start = asctof(yytext);
}
"Eq_End="{NUMBER}{COM} {
	camcfg->cameraEq_End = asctof(yytext);
}

%{
	//   StripRange ( calculated from hfreq ? ) 
%}

%{ 
   /*
    * --------------------------------------------------------------------
    *
    *	misc control
    *
    * --------------------------------------------------------------------
    */ 
%}
"External_Trigger="{NUMBER}{COM} {
	camcfg->externalTrigger = asctof(yytext);
}
"VSync_Trigger_Polarity="{NUMBER}{COM} {
	camcfg->externalTriggerPolarity = asctof(yytext); // ??????????????????????
}
"Flag_Interlace="{NUMBER}{COM} {
	camcfg->flagInterlace = asctof(yytext);
}
"Start_Field="{NUMBER}{COM} {
	camcfg->Start_Field =  asctof(yytext);
}
"External_Clock="{NUMBER}{COM} {
	camcfg->externalClock = asctof(yytext);
}
"Flag_Digital_Cam="{NUMBER}{COM} {
	camcfg->Flag_DigitalCamera = asctof(yytext);
} 
"Flag_Video_AC_Couple="{NUMBER}{COM} {
	camcfg->Flag_Video_AC_Couple = asctof (yytext);
}
"Flag_Sync_DC_Couple="{NUMBER}{COM} {
	camcfg->Flag_Sync_DC_Couple = asctof (yytext);
}
"Flag_Sync_Termination="{NUMBER}{COM} {
	camcfg->Flag_Sync_Termination = asctof (yytext);
}
%{
  // bitPerPixel ??????????
%}
"Flag_2Bit_Shiftdown="{NUMBER}{COM} {
	camcfg->bitmode = asctof(yytext);
}
"Flag_Line_Scan="{NUMBER}{COM} {
	camcfg->lineScanCamera = asctof (yytext);
}
"External_Sync_Input="{NUMBER}{COM} {
	camcfg->External_Sync_Input = asctof(yytext);
}
"External_CSync_Input="{NUMBER}{COM} {
	camcfg->External_CSync_Input =asctof(yytext);
}
"HSync_Polarity="{NUMBER}{COM} {
	camcfg->HSync_Polarity = asctof(yytext);
}
"H_Max_Capture_Size="{NUMBER}{COM} {
	camcfg->MaxCaptureSizeH = asctof(yytext);
}
"V_Max_Capture_Size="{NUMBER}{COM} {
	camcfg->MaxCaptureSizeV = asctof(yytext);
}
"Flag_LDV_Inv="{NUMBER}{COM} {
	ignored(yytext); 
}
"Flag_FDV_Inv="{NUMBER}{COM} {
	ignored(yytext); 
}
"Flag_PCLK_Inv="{NUMBER}{COM} {
	ignored(yytext); 
}
"Flag_Partial_Frame_Rmv="{NUMBER}{COM} {
	ignored(yytext); 
}
"Flag_DCI_Integration="{NUMBER}{COM} {
	ignored(yytext); 
}
"Flag_DCI_Double_Pulse="{NUMBER}{COM} {
	ignored(yytext); 
}
"Camera_Working_Mode="{NUMBER}{COM} {
	ignored(yytext); 
}
"Counter_Clock_Source="{NUMBER}{COM} {
	ignored(yytext); 
}
"Counter_Value="{NUMBER}{COM} {
	ignored(yytext); 
}
"Counter_Ext_Trig_En="{NUMBER}{COM} {
	ignored(yytext); 
}
"Counter_Ext_Trig_Pola="{NUMBER}{COM} {
	ignored(yytext); 
}
"Flag_LS_Exp_En="{NUMBER}{COM} {
	ignored(yytext); 
}
"LS_Exp_Start="{NUMBER}{COM} {
	ignored(yytext); 
}
"LS_Exp_End="{NUMBER}{COM} {
	ignored(yytext); 
}



















"Tim_Gen_Enable="{NUMBER}{COM} {
	ignored(yytext); 
}
"Data_Packing="{NUMBER}{COM} {
	ignored(yytext);
}
"Use_Module_Sync_Clock="{NUMBER}{COM} {
	ignored(yytext);
}
"Flag_White_Cable="{NUMBER}{COM} {
	ignored(yytext);
}
"Flag_MiniBNC_Cable="{NUMBER}{COM} {
	ignored(yytext);
}
"FST_EXP_Pola_Jp="{NUMBER}{COM} {
	ignored(yytext);
}

"quit"|"exit"|"bye"|":q"|"q"|"Q"|":Q" { exit(0); }
"save"" "*.* {sscanf(yytext,"%80s %80s",filename,filename);}
"r" { }
{SPC}\[.*
{SPC};.* {}

 {}
.*            printf( "unknown statement: %s\n", yytext ); 

%%

double asctof(char *str) {
	float num;
	int len;
	while((*str != '=') && (*str)) str++;
	if(!*str) return -1;
	str++;
//	printf("reststr ist %s\n",str);
	len = strlen(str);
	if((len > 1) && (str[1]=='x')) {
		int hex;
		sscanf(str,"%x",&hex);
		num=hex;
	}
	else {
		sscanf(str,"%g",&num);
	}
//	printf("num ist %f\n",num);
	return num;
}

int
MV1_LoadCameraConfigFile( MV1_CamConfig *cfg,char *cfname) {
	yyin = fopen(cfname,"r");
	if(yyin == NULL) {
		return -1;
	}
	read_camcfg(cfg);
	return MV1_OK;
}
/*
int
main(int argc, char **argv){ 
	MV1_CamConfig cfg;
 	if ( argc > 1 )
          yyin = fopen( argv[1], "r" );
        else
        yyin = stdin;
 	fflush(stdout);
	read_camcfg(&cfg);
       // yylex();
	exit(0);
}
*/
